﻿Public Class Form1

    Private Sub Panel_見える_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Panel_見える.Paint
        With e.Graphics
            Dim origin As PointF = New PointF(PictureBox_見えない.Image.Width / 2, PictureBox_見えない.Image.Height / 2)
            Dim scale As Single = Me.HScrollBar_拡大縮小.Value / 10
            Dim angle As Single = Me.HScrollBar_回転.Value
            Dim scrollOffset As PointF = New PointF(Me.HScrollBar_そしてスクロールX.Value, Me.HScrollBar_そしてスクロールY.Value)

            ' 変換ルール（逆順に適用される。上から順に適用するには各アクセサーにSystem.Drawing.Drawing2D.MatrixOrder.Appendを与える）
            .TranslateTransform(scrollOffset.X, scrollOffset.Y)         ' 4. スクロール
            .TranslateTransform(origin.X, origin.Y)                     ' 3. 中心が本来の位置になるよう移動
            .ScaleTransform(scale, scale)                               ' 2. 拡大・縮小
            .RotateTransform(angle)                                     ' 1. (0, 0)を中心に回転
            .DrawImage(Me.PictureBox_見えない.Image, -origin.X, -origin.Y)  ' 0. (0, 0)に回転と拡大の中心を合わせるように描画

            ' 拡大・縮小、回転の中心に□を描いてみる
            .ResetTransform()
            .DrawRectangle(Pens.Red, origin.X + scrollOffset.X, origin.Y + scrollOffset.Y, 3, 3)
        End With
    End Sub

    Private Sub Button_リセットボタン_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_リセットボタン.Click
        HScrollBar_拡大縮小.Value = 10
        HScrollBar_回転.Value = 0
        HScrollBar_そしてスクロールX.Value = 200
        HScrollBar_そしてスクロールY.Value = 200
        Panel_見える.Invalidate()
    End Sub

    Private Sub HScrollBar_拡大縮小_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar_拡大縮小.Scroll
        Panel_見える.Invalidate()
    End Sub

    Private Sub HScrollBar_回転_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar_回転.Scroll
        Panel_見える.Invalidate()
    End Sub

    Private Sub HScrollBar_そしてスクロールX_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar_そしてスクロールX.Scroll
        Panel_見える.Invalidate()
    End Sub

    Private Sub HScrollBar_そしてスクロールY_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar_そしてスクロールY.Scroll
        Panel_見える.Invalidate()
    End Sub

End Class
